--- old/usr/src/cmd/mdb/common/mdb/mdb_demangle.c	Tue Jun  5 20:45:28 2018
+++ new/usr/src/cmd/mdb/common/mdb/mdb_demangle.c	Tue Jun  5 20:45:28 2018
@@ -229,7 +229,9 @@
 	}
 
 	if (prefixlen > 0)
-		(void) strlcpy(dmp->dm_buf, name, prefixlen);
+		(void) strlcpy(dmp->dm_buf, name, prefixlen + 1);
+	else
+		*dmp->dm_buf = '\0';
 
 	if (res != NULL) {
 		(void) strlcat(dmp->dm_buf, res, dmp->dm_len);
@@ -327,6 +329,12 @@
 	if ((flags & DCMD_ADDRSPEC) || argc == 0)
 		return (DCMD_USAGE);
 
+	if (mdb.m_demangler == NULL && (mdb.m_demangler =
+	    mdb_dem_load()) == NULL) {
+		mdb_warn("failed to load demangler");
+		return (DCMD_ERR);
+	}
+
 	for (; argc != 0; argc--, argv++) {
 		mdb_printf("%s == %s\n", argv->a_un.a_str,
 		    mdb_dem_convert(mdb.m_demangler, argv->a_un.a_str));
